#!/usr/bin/env python
# -*- encoding: utf-8 -*-
# ETL. import csv file with preformatted data comes from Mexal orders
# use: import.csv mexal_file_csv.csv

# Modules required:
import xmlrpclib, csv, sys, ConfigParser, datetime
from posta import *
import sys, time, os # for get date of file

# Start main code *************************************************************
if len(sys.argv)!=2 :
   print """
         *** Syntax Error! ***
         *  Use the command with this syntax: python ./import_fatturato.py fatmeseoerp.FIA
         *********************
         """ 
   sys.exit()

# Funzioni:
def prepare(valore):  
    # For problems: input win output ubuntu; trim extra spaces
    #valore=valore.decode('ISO-8859-1')
    valore=valore.decode('cp1252')
    valore=valore.encode('utf-8')
    return valore.strip()

def prepare_date(valore):
    valore=valore.strip()
    if len(valore)==8:
       if valore: # TODO test correct date format
          return valore[:4] + "/" + valore[4:6] + "/" + valore[6:8]
    return '' #time.strftime("%d/%m/%Y") (per gli altri casi)

def prepare_float(valore):
    valore=valore.strip() 
    if valore: # TODO test correct date format       
       return float(valore.replace(",","."))
    else:
       return 0.0   # for empty values
       
def get_partner_id(sock, uid, pwd, mexal_id):
    ''' Ricavo l'ID del partner dall'id di mexal
    '''
    item_id = sock.execute(dbname, uid, pwd, 'res.partner', 'search', [('ref', '=', mexal_id)])
    if item_id:
       return item_id[0]
    return 0   

def get_partner_name(sock, uid, pwd, partner_id):
    ''' Ricavo il nome del partner
    '''
    partner_read = sock.execute(dbname, uid, pwd, 'res.partner', 'read', partner_id)
    if partner_read:
       return partner_read['name']
    return ''

FileInput=sys.argv[1]
if FileInput:
   sigla_azienda=FileInput[-3:].lower()
else:
   print "[ERR] File input non presente!"
   sys.exit()   
if sigla_azienda in ('gpb','fia'):
   cfg_file=sigla_azienda + ".openerp.cfg"
else:
   print "[ERR] Sigla azienda non trovata!"
   sys.exit()        

# Ricavo la data del file per comunicarla
create_date=time.ctime(os.path.getctime(FileInput))    
    
# Set up parameters (for connection to Open ERP Database) ********************************************
config = ConfigParser.ConfigParser()
config.read([cfg_file]) # if file is in home dir add also: , os.path.expanduser('~/.openerp.cfg')])
dbname = config.get('dbaccess','dbname')
user = config.get('dbaccess','user')
pwd = config.get('dbaccess','pwd')
server = config.get('dbaccess','server')
port = config.get('dbaccess','port')   # verify if it's necessary: getint
separator = config.get('dbaccess','separator') # test
verbose = eval(config.get('import_mode','verbose')) #;verbose=True

verbose= False # TODO togliere
debug=True

smtp_sender = config.get('smtp', 'sender')
smtp_receiver = config.get('smtp', 'receiver')
smtp_subject = config.get('smtp', 'subject') + " (Importazione fatturato cliente)"
smtp_text = config.get('smtp', 'text')
smtp_log = config.get('smtp', 'log_file') + ".fatturato.csv"
smtp_server = config.get('smtp', 'server')
#verbose_mail: True

# Open file log error (if verbose mail the file are sent to admin email)
try: 
   out_file = open(smtp_log,"w")
except:
   print "[WARNING]","Error creating log files:", smtp_log
   # No raise as it'a a warning

header_lines = 0 # mai da mexal
# XMLRPC connection for autentication (UID) and proxy 
sock = xmlrpclib.ServerProxy('http://' + server + ':' + port + '/xmlrpc/common', allow_none=True)
uid = sock.login(dbname ,user ,pwd)
sock = xmlrpclib.ServerProxy('http://' + server + ':' + port + '/xmlrpc/object', allow_none=True)

# Open CSV passed file (see arguments) mode: read / binary, delimiation char 
lines = csv.reader(open(FileInput,'rb'),delimiter=separator)
counter={'tot':-header_lines,'new':0,'upd':0,} # tot negative (jump N lines)

# Elimino tutto
errore_da_comunicare=False
print "Elimino vecchio archivio invoice!"

elimino_invoice = sock.execute(dbname, uid, pwd, 'statistic.invoice', 'unlink', sock.execute(dbname, uid, pwd, 'statistic.invoice', 'search', []))
elimino_trend = sock.execute(dbname, uid, pwd, 'statistic.trend', 'unlink', sock.execute(dbname, uid, pwd, 'statistic.trend', 'search', []))
elimino_trendoc = sock.execute(dbname, uid, pwd, 'statistic.trendoc', 'unlink', sock.execute(dbname, uid, pwd, 'statistic.trendoc', 'search', []))

print "Inizio importazione"
# Carico gli elementi da file CSV:
tot_col=0
try:
    for line in lines:
        if tot_col==0: # memorizzo il numero colonne la prima volta
           tot_col=len(line)
           print "[INFO] Colonne rilevate", tot_col
           raise_error("[INFO] Procedura: %s \n\tFile importato: %s [creazione: %s]"%(sys.argv, FileInput, create_date), out_file)
        if counter['tot']<0:  # salto le N righe di intestazione
           counter['tot']+=1
        else:   
           if len(line) and (tot_col==len(line)): # salto le righe vuote e le righe con colonne diverse
               counter['tot']+=1 
               try:
                   csv_id=0       # Codice cliente di mexal forma (NNN.NNNNN)
                   mexal_id = prepare(line[csv_id])
                   csv_id+=1      # Mese
                   month = int(prepare(line[csv_id]) or 0 )
                   csv_id+=1      # Anno
                   year = prepare(line[csv_id]) 
                   csv_id+=1      # Totale
                   total_invoice = prepare_float(line[csv_id]) or 0.0
                   csv_id+=1      # Type (oc or ft)
                   type_document = prepare(line[csv_id]).lower()

                   # Problema M Business:
                   if mexal_id in ('06.00052', '06.00632', '06.01123', '06.01125', '06.01126', '06.01127', '06.01129', '06.01131', 
                                   '06.01132', '06.01136', '06.01137', '06.01138', '06.01139', '06.01142', '06.01143', '06.01146', 
                                   '06.01147', '06.01149', '06.01151', '06.01153', '06.01154', '06.01155', '06.01159', '06.01161', 
                                   '06.01163', '06.01164', '06.01165', '06.01166', '06.01167', '06.01168', '06.01170', '06.01171', 
                                   '06.01175', '06.01177', '06.01178', '06.01179', '06.01221', '06.01231', '06.01260', '06.01317', 
                                   '06.01386', '06.01408', '06.01416', '06.01420', '06.01421', '06.01424', '06.01436', '06.01439', 
                                   '06.01481', '06.01501', '06.01532', '06.01538', '06.01580', '06.01609', '06.01764', '06.01797', 
                                   '06.02081', '06.02117', '06.02348', '06.02408', '06.02409', '06.02709', '06.02888', '06.03043', 
                                   '06.03629', '06.03788', ):
                      raise_error("[WARNING] Riga %s: sostituito codice: %s con: 06.03044 (Problema M Business)" % (counter['tot'], mexal_id), out_file) 
                      mexal_id='06.03044'
                                   
                   # Calculated field:
                   partner_id = get_partner_id(sock, uid, pwd, mexal_id)
                   if not partner_id:
                      raise_error("[ERR] Riga: %s Partner non trovato, codice: %s" % (counter['tot'], mexal_id), out_file) 
                      errore_da_comunicare=True
                      partner_name=">> Partner non trovato %s"%(mexal_id or "")
                   else:
                      partner_name = get_partner_name(sock, uid, pwd, partner_id)
   
                   if not total_invoice: 
                      if verbose: 
                         raise_error("[WARN] Riga: %s Importo non trovato! Riga: %s"%(counter['tot'], line,), out_file)                          
                         # Nessun errore può capitare
                         continue # passo alla riga successiva
                         
                   if not (month or year): # lo importo lo stesso così si vede nei non class.
                      raise_error("[ERR] Riga: %s Mese o anno non trovato! %s"%(counter['tot'], line,), out_file)                          
                      errore_da_comunicare=True
                         
                   # Attualizzo gli OC se sono più vecchi di oggi
                   if (type_document=='oc') and ("%s%02d"%(year, month) < datetime.datetime.now().strftime("%Y%m")): # OC: attualizzo il mese attuale se sono precedenti a oggi
                      if debug:
                         raise_error("[DEBUG] Attualizzo OC datato: %s%02d, riga %s, cliente: %s, totale %s"%(year, month, counter['tot'], mexal_id, total_invoice), out_file)
                      year = datetime.datetime.now().strftime("%Y")
                      month = int(datetime.datetime.now().strftime("%m"))
                      
                   data = {"name": "%s [%s]"%(partner_name, mexal_id,), 
                           "partner_id": partner_id,
                           "month": month, 
                           "type_document": type_document,
                          }

                   # Calcolo in quale anno inserire il fatturato (specchio di 3)  
                   anno_mese = "%s%02d"%(year, month) 
                   
                   anno_attuale = int(datetime.datetime.now().strftime("%Y"))
                   mese_attuale = int(datetime.datetime.now().strftime("%m"))
                   
                   if mese_attuale >=1 and mese_attuale <=8:
                      anno_riferimento = anno_attuale - 1 # la stagione è partita l'anno scorso
                   elif mese_attuale >=9 and mese_attuale <=12:
                      anno_riferimento = anno_attuale  # la stagione è partita l'anno scorso
                   else:   
                      raise_error("[ERR] Riga: %s - Errore mese attuale"%(counter['tot']), out_file) 
                      errore_da_comunicare=True

                   # Periodo settembre - anno attuale >> agosto - anno prossimo
                   if anno_mese >= "%s09"%(anno_riferimento,) and anno_mese <= "%s08"%(anno_riferimento + 1,): # current
                      data['total'] = total_invoice 
                   elif anno_mese >= "%s09"%(anno_riferimento -1,) and anno_mese <= "%s08"%(anno_riferimento,): # anno -1
                      data['total_last'] = total_invoice
                   elif anno_mese >= "%s09"%(anno_riferimento -2,) and anno_mese <= "%s08"%(anno_riferimento -1,): # anno -2
                      data['total_last_last'] = total_invoice 
                   else:                      
                      raise_error("[WARING] Riga:%s - Anno-mese non trovato nelle tre stagioni da considerare: %s-%s"%(counter['tot'], year, month), out_file)
                      errore_da_comunicare=True
                         
                   try:
                      invoice_id = sock.execute(dbname, uid, pwd, 'statistic.invoice', 'create', data)
                   except:
                      raise_error("[ERR] Riga: %s Errore creando fatturato: %s"%(counter['tot'], mexal_id), out_file)
                      errore_da_comunicare=True
                   if verbose: 
                      raise_error("[INFO] Riga: %s Fatturato inserito: %s"%(counter['tot'], mexal_id), out_file)
                         
               except:
                   raise_error("[ERR] Riga: %s Errore di importazione: %s"%(counter['tot'], sys.exc_info()[0]), out_file)
                   errore_da_comunicare=True
           else:
               raise_error("[ERR] Riga: %s Riga vuota o con colonne diverse: col attuale=%s col effettive=%s"%(counter['tot'],tot_col,len(line)), out_file)
               errore_da_comunicare=True

    raise_error("[INFO] Importazione terminata! Totale elementi %s"%(counter['tot'],), out_file)

    for documento in ['oc', 'ft', 'bc',]:
        print "Ricavo i dati per statistic.trend" + documento # Fatture e OC+FAtture
        if documento=="ft": # Solo fatture
           invoice_ids = sock.execute(dbname, uid, pwd, 'statistic.invoice', 'search', [('type_document','=','ft')])
        else: # tutto oc + ft + bc
           invoice_ids = sock.execute(dbname, uid, pwd, 'statistic.invoice', 'search', [])

        if invoice_ids:
           # Elimino precedenti
           if documento=="ft":
              trend_ids = sock.execute(dbname, uid, pwd, 'statistic.trend', 'search', [])
              remove_trend = sock.execute(dbname, uid, pwd, 'statistic.trend', 'unlink', trend_ids)
           else:
              trend_ids = sock.execute(dbname, uid, pwd, 'statistic.trendoc', 'search', [])
              remove_trend = sock.execute(dbname, uid, pwd, 'statistic.trendoc', 'unlink', trend_ids)
           
           # Carico nella lista tutti i valori divisi per partner:
           item_list={}
           total_invoiced=[0.0, 0.0, 0.0] # year -2, year -1, year 0       
           for item in sock.execute(dbname, uid, pwd, 'statistic.invoice', 'read', invoice_ids): # in funzione del documento
               partner_id=(item['partner_id'] and item['partner_id'][0]) or 0
               
               if partner_id not in item_list:
                  item_list[partner_id]=[0.0,0.0,0.0] # year -2, year -1, year 0

               if item['total']: # anno attuale
                  item_list[partner_id][2] += item['total']
                  total_invoiced[2] += item['total']
               if item['total_last']: # anno -1
                  item_list[partner_id][1] += item['total_last']
                  total_invoiced[1] += item['total_last']
               if item['total_last_last']: # anno -2
                  item_list[partner_id][0] += item['total_last_last']
                  total_invoiced[0] += item['total_last_last']

        print "Inserisco i dati nell'archivio statistico per " + documento 
        for elemento_id in item_list.keys(): # passo tutti gli elementi inserendoli in archivio col calcolo perc.
            data={'name': "cliente: %d" % (elemento_id,), #"%s [%d €]" % (number, total) ,
                  'partner_id': elemento_id,
                  'total': item_list[elemento_id][2],
                  'total_last': item_list[elemento_id][1],
                  'total_last_last': item_list[elemento_id][0],
                  'percentage': (total_invoiced[2]) and (item_list[elemento_id][2] * 100 / (total_invoiced[2])), # current year
                  'percentage_last': (total_invoiced[1]) and (item_list[elemento_id][1] * 100 / (total_invoiced[1])), # current year
                  'percentage_last_last': (total_invoiced[0]) and (item_list[elemento_id][0] * 100 / (total_invoiced[0])), # current year
                  }
            try:
               if documento=="ft":
                  trend_id = sock.execute(dbname, uid, pwd, 'statistic.trend', 'create', data)
               else:
                  trend_id = sock.execute(dbname, uid, pwd, 'statistic.trendoc', 'create', data)
                  
            except:
               raise_error("[ERR] Errore creando ordine id_partner: %s"%(elemento_id,), out_file)
               errore_da_comunicare=True
            if verbose: 
               raise_error("[INFO] Fatturato del partner %d inserito:"%(elemento_id,), out_file)

        if debug:
           print item_list
    out_file.close()           
except:
    print raise_error('[ERR] Errore importando gli ordini!', out_file)
    #raise 

send_mail(smtp_sender,[smtp_receiver,],smtp_subject,smtp_text,[smtp_log,],smtp_server)

